
// This declares an external variable require by the Misc_daemon routines.
// it is a flag that, when set to true, causes debugging messages to be
// logged.  In the future, we may decide to use a better mechanism.  Note
// that there is no "Misc" prefix; if you defined your own debug variable
// problems are sure to arise, even though they may not be obvious ones.
// The original intent was for people to declare their own "debug" and
// then the Misc_daemon routines would hook into that and use it.  But
// with EOF requiring use of -all_load, this _must_ be declared even if
// you don't use the Misc_daemon routines.  And thus people get confused.
// hopefully this will alleviate confusion and not cause new problems.
// And hopefully there will be a cleaner, MiscKit-wide, solution for
// turning all debugging messages on and off through a central clearinghouse.

#import <objc/objc.h>

int debug = NO;