/************************************************************************
  CATEGORY:			MiscFile (Creation)
  CONFORMS TO:		None
  PROGRAMMER:		Todd Thomas	 (todd@avocado.supernet.ab.ca)
  BEGAN:			December 10, 1994
  VERSION:			0.1		
  CHANGES:			-	

  Adds the ability to create more MiscFiles from a single one.
     
 *************************************************************************/

#import "MiscFile.h"


@interface MiscFile (Creation)

- (MiscFile *)createCopyNamed: (const char *)newPath;
- (MiscFile *)createSymbolicLinkNamed: (const char *)newLink;
- (MiscFile *)createHardLinkNamed: (const char *)newLink;

@end
