{\rtf0\ansi{\fonttbl\f0\fmodern Courier;}
\paperw11760
\paperh7800
\margl120
\margr120
\pard\tx560\tx1140\tx1680\tx2260\tx2800\tx3440\tx3920\tx4600\tx10360\tx11520\f0\b0\i0\ulnone\fs24\fc0\cf0 /************************************************************************\
  CATEGORY:			MiscFile\
\
  See the header for more information.\
 *************************************************************************/\
\
//#import <sys/stat.h>\
#import "MiscFileDefs.h"\
#import "MiscFile+Unix.h"\
#import "MiscFile+Info.h"\
\
\

\b @implementation MiscFile (Info)
\b0 \
\

\b - (BOOL)isSymbolicLink
\b0 \
\{\
  	struct stat  s;\
  \

\pard\tx560\tx1120\tx1680\tx2240\tx2800\tx3380\tx3920\tx4460\tx10360\tx11520\fc0\cf0 	if ([ self lstat: &s] != MISCFILE_NOERROR)\
		return NO;\
		\
	if ((s.st_mode & S_IFMT) == S_IFLNK)\
		return YES;\
		\
	return NO;\

\pard\tx560\tx1140\tx1680\tx2260\tx2800\tx3440\tx3920\tx4600\tx10360\tx11520\fc0\cf0 \}\
\
\
// You could probably use MiscGraphNode's -isLeaf method but that loads\
// all the children just to find out if it is a leaf. This way we just use\
// stat.\
\

\b - (BOOL)isDirectory
\b0 \
\{\
  	struct stat  s;\
	if ([self stat: &s] != MISCFILE_NOERROR)\
		return NO;\
		\

\pard\tx560\tx1120\tx1680\tx2240\tx2800\tx3380\tx3920\tx4460\tx10360\tx11520\fc0\cf0 	if ((s.st_mode & S_IFMT) == S_IFDIR) \
		return YES;\

\pard\tx560\tx1140\tx1680\tx2260\tx2800\tx3440\tx3920\tx4600\tx10360\tx11520\fc0\cf0 		\
	return NO;\
\}\
\
\

\b - (u_short)permissions
\b0 \
\{\
	struct stat  s;\
	if ([self stat: &s] != MISCFILE_NOERROR)\
		return s.st_mode;\
	else \
		return -1; //What should be returned??\
\}\

\b \
\
- (dev_t)device
\b0 \
\{\
	struct stat  s;\
	if ([self stat: &s] != MISCFILE_NOERROR)\
		return s.st_dev;\
	else \
		return -1; //What should be returned??\
\}\
\
	\
// This will be replaced by -(MiscUser *)owner in the real release.\

\b - (uid_t)userID
\b0 \
\{\
	struct stat  s;\
	if ([self stat: &s] != MISCFILE_NOERROR)\
		return s.st_uid;\
	else \
		return -1; //What should be returned??\
\}\
\
\
// This will be replaced by -(MiscGroup *)group in the real release.\

\b - (gid_t)groupID
\b0 \
\{\
	struct stat  s;\
	if ([self stat: &s] != MISCFILE_NOERROR)\
		return s.st_gid;\
	else \
		return -1; //What should be returned??\
\}\
\
\

\b - (off_t)size
\b0 \
\{\
	struct stat  s;\
	if ([self stat: &s] != MISCFILE_NOERROR)\
		return s.st_size;\
	else \
		return -1; //What should be returned??\
\}\
\
\

\b - (short)hardLinks
\b0 \
\{\
	struct stat  s;\
	if ([self stat: &s] != MISCFILE_NOERROR)\
		return s.st_nlink;\
	else \
		return -1; //What should be returned??\
\}\
\
\
// These will return (MiscTime *) objects in a future release.\

\b - (time_t)lastAccessTime
\b0 \
\{\
	struct stat  s;\
	if ([self stat: &s] != MISCFILE_NOERROR)\
		return s.st_atime;\
	else \
		return -1; //What should be returned??\
\}\
\
\

\b - (time_t)lastModifyTime
\b0 \
\{\
	struct stat  s;\
	if ([self stat: &s] != MISCFILE_NOERROR)\
		return s.st_mtime;\
	else \
		return -1; //What should be returned??\
\}\
\
\

\b - (time_t)lastStatusChange
\b0 \
\{\
	struct stat  s;\
	if ([self stat: &s] != MISCFILE_NOERROR)\
		return s.st_ctime;\
	else \
		return -1; //What should be returned??\
\}\
\
\

\b - (BOOL)readAccess
\b0 \
\{\
	if ([self access: MISCFILE_READ] == MISCFILE_NOERROR)\
		return YES;\
	return NO;\
\}\
\
	\

\b - (BOOL)writeAccess
\b0 \
\{\
	if ([self access: MISCFILE_WRITE] == MISCFILE_NOERROR)\
		return YES;\
	return NO;\
\}\
\
\

\b - (BOOL)executeAccess
\b0 \
\{\
	if ([self access: MISCFILE_EXECUTE] == MISCFILE_NOERROR)\
		return YES;\
	return NO;\
\}\
\
\

\b - (BOOL)doesExist
\b0 \
\{\
	if ([self access: MISCFILE_EXISTS] == MISCFILE_NOERROR)\
		return YES;\
	return NO;\
\}\
\

\b @end
\b0 \

}
