{\rtf0\ansi{\fonttbl\f0\fmodern Courier;}
\paperw11760
\paperh7800
\margl120
\margr120
\pard\tx560\tx1140\tx1680\tx2260\tx2800\tx3440\tx3920\tx4600\tx10360\tx11520\f0\b0\i0\ulnone\fs24\fc0\cf0 /************************************************************************\
  CATEGORY:			MiscFile (Modification)\
\
  See the header for more information.\
 *************************************************************************/\
\
//#import "MiscFileDefs.h"\
//#import <bsd/libc.h>\
//#import <bsd/errno.h>\
#import "MiscFile+Info.h"\
#import "MiscFile+Unix.h"\
#import "MiscFile+Modification.h"\
\
\

\b @implementation MiscFile (Modification)
\b0 \
/*\

\b - (int)renameFileTo: (const char *)newPathname\

\b0 \{\
	// Renames the receiver to the newly given pathname.\
	return 0;\
\}\
*/\
\
// Resets owner/group/other to what you give in perms.\

\b - (int)setPermissions: (int)perms for: (int)who
\b0 \
\{\
	// Sets the permission of the receiver. If successful, zero is returned.\
	// Otherwise the error code is returned. The arg perms can any ORed combo. \
	// of MISCFILE_READ, MISCFILE_WRITE, or MISCFILE_EXECUTE. \
	// The who message can be any ORed value of  MISCFILE_OWNER, 	\
	// MISCFILE_GROUP, or MISCFILE_OTHER.\
	// Example : [self changePermission: MISCFILE_READ | MISCFILE_EXECUTE for:\
	//	MISCFILE_GROUP]. This is the same as "chmod 050 filename" (I think :-)\
	int  mode = 0;\
	\
	if (who & MISCFILE_OWNER)\
		mode |= perms << 6;\
	if (who & MISCFILE_GROUP)\
		mode |= perms << 3;\
	if (who & MISCFILE_OTHER)\
		mode |= perms;\
\
	return [self chmod: mode];\
\}\
\
\
// Adds permissions given while leaving the rest alone.\

\b - (int)addPermissions: (int)perms for: (int)who
\b0 \
\{\
	int  currMode = (int)[self permissions];\
	int  mode = 0;\
	\
	if (who & MISCFILE_OWNER)\
		mode |= perms << 6;\
	if (who & MISCFILE_GROUP)\
		mode |= perms << 3;\
	if (who & MISCFILE_OTHER)\
		mode |= perms;\
\
	mode |= currMode;\
	return [self chmod: mode];\
\}\
	\
\
// Removes permissions given while leaving the rest alone.\

\b - (int)removePermissions: (int)perms for: (int)who
\b0 \
\{\
	int  currMode = (int)[self permissions];\
	int  mode = 0;\
	\
	if (who & MISCFILE_OWNER)\
		mode |= perms << 6;\
	if (who & MISCFILE_GROUP)\
		mode |= perms << 3;\
	if (who & MISCFILE_OTHER)\
		mode |= perms;\
\
	mode ^= currMode;\
	return [self chmod: mode];\
\}\
\

\b @end
\b0 \

}
