{\rtf0\ansi{\fonttbl\f0\fmodern Courier;}
\paperw11760
\paperh7800
\margl120
\margr120
\pard\tx560\tx1140\tx1680\tx2260\tx2800\tx3440\tx3920\tx4600\tx10360\tx11520\f0\b0\i0\ulnone\fs24\fc0\cf0 /************************************************************************\
  CATEGORY:			MiscFile (Unix)\
\
  See the header for more information.\
 *************************************************************************/\
\
#import <sys/types.h>\
#import <errno.h>\
#import <libc.h>				// for chmod(2) and chown(2)\
#import <sys/stat.h>			// for stat(2)\
#import <sys/file.h>			// for access(2)\
#import "MiscFile+Unix.h"\
\
// NeXT's headers don't seem to declare this anywhere...it is supposed to\
// be in <bsd/sys/file.h> but it isn't.\
extern int access (const char *path, int mode);\
\

\b @implementation MiscFile (Unix)
\b0 \
\

\b - (int)access: (int)mode\

\b0 \{\
	int  retVal = access ([self fullPath], mode);\
	if (retVal == -1)\
		return errno;\
\
	return 0;\
\}\
\
\

\b - (int)stat: (struct stat *)stats
\b0 \
\{\
	int  retVal = stat ([self fullPath], stats);\
	if (retVal == -1)\
		return errno;\
	\
	return 0;\
\}\
\
\

\b - (int)lstat: (struct stat *)stats
\b0 \
\{\
	int  retVal = lstat ([self fullPath], stats);\
	if (retVal == -1)\
		return errno;\
	\
	return 0;\
\}\
\
\

\b - (int)chmod: (unsigned short)mode\

\b0 \{\
	int  retVal = chmod([self fullPath], mode);\
	if (retVal == -1)\
		return errno;\
\
	return 0;\
\}\
\
\

\b - (int)chown: (uid_t)owner group: (gid_t)group
\b0 \
\{\
	int retVal = chown ([self fullPath], owner, group);\
	if (retVal == -1)\
		return errno;\
	\
	return 0;\
\}	\
\
\

\b - (int)link: (const char *)newpath
\b0 \
\{\
	int retVal = link ([self fullPath], newpath);\
	if (retVal == -1)\
		return errno;\
	\
	return 0;\
\}\
\
\

\b - (int)symlink: (const char *)newpath
\b0 \
\{\
	int retVal = symlink ([self fullPath], newpath);\
	if (retVal == -1)\
		return errno;\
	\
	return 0;\
\}\
\

\b @end
\b0 \

}
