// This is almost the same as a PickList, but the .nib has no controls
// to change the list.  By using a different class name we can load a
// different .nib for free via the MiscNibController machinery.  We do
// duplicate the class methods to grab the picklist so that you can
// have a mutable and non-mutable version...

// Do NOT allocate these yourself; use the +findPickListNamed: method!

#import "MiscPickList.h"

@interface MiscStaticPickList : MiscPickList
{
}

+ findPickListNamed:(MiscString *)aName;
- popUp:sender;
- addItemToList:(MiscString *)anItem value:(MiscString *)aValue;
- removeItemFromList:(MiscString *)anItem;

@end
