/**********************************************************************
  CLASS:			MyNXBrowserCell
  
  Simply adds the ability of each cell to know what MiscFile they are
  representing. Therefore in the browser when a cell is clicked on, you
  can immediately lookup it's children (if any) or anything else you 
  need to know about.
  
  See MyController.m (BrowserDelegate) -browser:fillMatrix:inColumn:
  
 ***********************************************************************/
#import <appkit/appkit.h>


@interface MyNXBrowserCell : NXBrowserCell
{
	id  miscFile;		// points to the MiscFile that the cell represents
}

- init;
- setFile: aFile;
- file;

@end
