{\rtf0\ansi{\fonttbl\f0\fmodern Courier;}
\paperw11760
\paperh7800
\margl120
\margr120
\pard\tx560\tx1140\tx1680\tx2260\tx2800\tx3440\tx3920\tx4600\tx10360\tx11520\f0\b0\i0\ulnone\fs24\fc0\cf0 /************************************************************************\
  CATEGORY:			MiscFile (Creation)\
\
  See the header for more information.\
 *************************************************************************/\
\
#import "MiscFile+Unix.h"\
#import "MiscFile+Creation.h"\
\
\

\b @implementation MiscFile (Creation)
\b0 \
\

\b - (MiscFile *)createCopyNamed: (const char *)newFile
\b0 \
\{\
	// Actually copies the contents of the receiver into newFile and\
	// returns the MiscFile if successful. Otherwise nil is returned.\
	// You are responsible for freeing the MiscFile returned.\
	// NOT IMPLEMENTED YET :-)\
	return nil;\
\}\
\
\
\

\b - (MiscFile *)createSymbolicLinkNamed: (const char *)newLink
\b0 \
\{\
	// Creates a symbolic link to the receiver and returns it. If there\
	// was an error, nil is returned.\
	// You are responsible for freeing the MiscFile returned.\
	if (newLink == NULL)\
		return nil;\
		\
	if ([self symlink: newLink] != MISCFILE_NOERROR)\
		return nil;\
\
	// The link must have been successful, so create an\
	// instance and return it.\
	return [ [MiscFile alloc] initWithPath: newLink];\
\
\}\
\
\
\

\b - (MiscFile *)createHardLinkNamed: (const char *)newLink
\b0 \
\{\
	// Creates a hard link to the receiver and returns it. If there was\
	// an error nil is returned.\
	// You are responsible for freeing the MiscFile returned.\
	if (newLink == NULL)\
		return nil;\
		\
	if ([self link: newLink] != MISCFILE_NOERROR)\
		return nil;\
\
	// The link must have been successful, so create an\
	// instance and return it.\
	return [ [MiscFile alloc] initWithPath: newLink];\
\}\
\

\b @end
\b0 \

}
